function init()
    tool_name = "shotgungs"
    RegisterTool(tool_name, "ShotGun", "MOD/vox/Shotgun.vox", 3)
	SetBool("game.tool." .. tool_name ..".enabled", true)
	SetFloat("game.tool." .. tool_name .. ".ammo", 101)
	unlimited_ammo = GetBool("savegame.mod.unlimitedammo")
	unlimited_clip = GetBool("savegame.mod.unlimitedclip")
	no_action = GetBool("savegame.mod.no_action")
	input_lever_action = GetString("savegame.mod.input_lever_action")
	input_type = GetString("savegame.mod.type_input")
	smoke_firing = GetFloat("savegame.mod.smoke_firing")
	smoke_impact = GetFloat("savegame.mod.smoke_impact")
	ammo_type = GetInt("savegame.mod.start_ammo")
	if input_lever_action == "" then input_lever_action = "C" end
	if input_type == "" then input_type = "V" end
	if smoke_firing == 0 then smoke_firing = 10 end
	if smoke_impact == 0 then smoke_impact = 20 end
	
	ammo = 4
	clip = 40
	aim_progress = 0
	bullets = {}
	loaded = false
	loading, reloading = false, false
	recoil = 0
	anim_l = {0, 0, 0}
	anim_r = {0, 0, 0}
	shell = {50, 0, 0, 1}
	shell_loaded = false
	
	
	firing_sound = LoadSound("MOD/snd/Firing.ogg")
	loading_sound = LoadSound("MOD/snd/Loading.ogg")
	loading_ammo_sound = LoadSound("MOD/snd/LoadAmmo.ogg")
end

function shoot()
    camera = GetPlayerCameraTransform()
	if not unlimited_ammo then ammo = ammo - 1 end
	local smokepos = 0
	if aim_progress == 0 then smokepos = TransformToParentPoint(camera, VecAdd(Vec(0, -0.2, -1.25), Vec(0.225, 0.075, -0.2))) else smokepos = TransformToParentPoint(camera, Vec(0, -0.05, -1.25)) end
	PointLight(smokepos, 1, 1, 0.7, 2)
	if smoke_firing > 0 then for i = 1, smoke_firing do
	    local smokedir = TransformToParentVec(camera, Vec(math.random()-0.5, math.random()-0.5, -(math.random()*3+0.1)))
	    smokedir = VecAdd(smokedir, VecScale(GetPlayerVelocity(), 0.75))
		ParticleType("plain")
        ParticleTile(5)
        local val = math.random()
        if val < 1/3 then
            ParticleColor(1, 0.3, 0)
        elseif val < 1/3*2 then
            ParticleColor(1, 0.2, 0)
        else
            ParticleColor(0, 0, 0)
        end
        ParticleRadius(0.05, 0.01)
        ParticleEmissive(5, 4)
        SpawnParticle(smokepos, smokedir, 0.5) 
	end end
	if ammo_type ~= 5 then for i = 1, 50 do 
	    local r = math.random()
	    local pos = VecScale(VecNormalize(Vec(math.random()-0.5, math.random()-0.5, 0)), r*r)
	    table.insert(bullets, {smokepos, VecNormalize(TransformToParentVec(camera, Vec(pos[1], pos[2], -15))), 0, 0}) 
	end else table.insert(bullets, {smokepos, TransformToParentVec(camera, Vec(0, 0, -1)), 0, 3}) end
	loaded = false
	recoil = 1
	PlaySound(firing_sound, GetPlayerCameraTransform().pos)
end
function eject_sheel()
    if shell_loaded then 
	    shell = {0, (math.random()-0.5)*20, 40+math.random()*10, 0.8+math.random()*0.4} 
	    shell_loaded = false
	end
end
function particleSystemgun(startPos, dir, dist, normal, shape)
    local gunPower = 0.8
    local hitPoint = VecAdd(startPos, VecScale(dir, dist-0.05))
	local mat,r,g,b,a = GetShapeMaterialAtPosition(shape, VecAdd(startPos, VecScale(dir, dist)))
	local vec = VecNormalize(VecAdd(normal, VecSub(Vec(0, 0, 0), dir)))
	local tr = Transform(Vec(0, 0, 0), QuatLookAt(Vec(0, 0, 0), dir))
	local percentSmoke, smokePower, total = 0.8, 0.5, 10
	if mat == "plaster" or mat == "masonry" or mat == "rock" or mat == "none" or mat == "" then percentSmoke, smokePower, total = 0.8, 0.5, 10 end
	if mat == "dirt" then percentSmoke, smokePower, total = 0.95, 0.7, 10 end
	if mat == "wood" or mat == "metal" or mat == "foliage" or mat == "glass" or mat == "heavymetal" or mat == "plastic" then percentSmoke, smokePower, total = 0.8, 0.4, math.max(math.floor(math.random()*5+0.5), 1) end
	if mat == "glass" then MakeHole(hitPoint, 1, 0, 0) end
	for u = 1, math.floor(total+0.5) do
	    ParticleReset()
		ParticleType("smoke")
		ParticleColor(r,g,b)
		ParticleAlpha(math.min(a, smokePower), 0)
		ParticleRadius(0.1*gunPower)
		ParticleTile(0)
		if math.random() < percentSmoke then
		if math.random() < 0.25 then
			SpawnParticle(VecAdd(hitPoint,  VecScale(normal, 0.2)), VecScale(VecAdd(vec, TransformToParentVec(tr, Vec((math.random()-0.5)*0.2, (math.random()-0.5)*0.2, (math.random()-0.5)*0.2))), (math.random()*5+5)*smokePower*gunPower), smokePower)
		else
			SpawnParticle(VecAdd(hitPoint,  VecScale(normal, 0.05)), VecScale(TransformToParentVec(tr, Vec((math.random()-0.5), (math.random()-0.5), 0)), 3), 1.5)
		end
		else
		ParticleType("plain")
		ParticleAlpha(a, a)
		ParticleRadius(0.1*math.max(1-percentSmoke, 0.4))
		ParticleTile(6)
		ParticleGravity(-math.random()-4, -5)
		ParticleSticky(0.6)
		SpawnParticle(VecAdd(hitPoint,  VecScale(normal, 0.2)), VecScale(VecAdd(vec, TransformToParentVec(tr, Vec((math.random()-0.5)*0.2, (math.random()-0.5)*0.2, (math.random()-0.5)*0.2))), (math.random()*9+1)*smokePower*gunPower), 10)
		end
	end 
end

function tick(dt)
    if GetString("game.player.tool") == tool_name and GetPlayerVehicle() == 0 then
	    if InputDown("lmb") and grabing then
		    grabing = 1
		else
		    grabing = GetPlayerGrabShape()
		end
		shell[1] = shell[1] + dt*13 * shell[4]
		local ShotGun_Shapes = GetBodyShapes(GetToolBody())
		local Shell_Shape = ShotGun_Shapes[5]
		SetShapeLocalTransform(ShotGun_Shapes[2], Transform(Vec(0.175, -0.4, -0.15), QuatEuler(-90, 0, 0)))
		SetShapeLocalTransform(ShotGun_Shapes[3], Transform(Vec(0.175, -0.275, -1), QuatEuler(-90, 0, 0)))
		SetShapeLocalTransform(Shell_Shape, Transform(Vec(0.175+shell[1]*0.5, -0.21, -0.84+shell[1]*0.3), QuatEuler(-90+shell[1]*shell[2], -shell[1]*shell[3], 0)))
		if grabing > 0 then grabing = true else grabing = false end
		recoil = math.max(recoil-dt*2, 0)
	    if InputPressed("lmb") and not reloading and not loading and loaded and not grabing and ammo > 0 then
		    shoot()
		end
		if InputPressed(input_type) then 
		    ammo_type = ammo_type + 1
			if ammo_type > 5 then ammo_type = 0 end
		end
		if InputPressed("lmb") and reloading then stop_reload = 1 end
		if InputPressed(input_lever_action) and reloading then stop_reload = 2 end
		if InputPressed("R") and loading then stop_reload = 3 end
		if InputPressed(input_lever_action) and loading then stop_reload = 4 end
		if InputPressed("R") and not reloading and clip > 0 and not loading and ((ammo < 5 and loaded) or (ammo < 4 and not loaded)) then 
		    reloading = true
			anim_r[1] = 1
			stop_reload = 0
		end
		if anim_r[1] == 1 then
		    anim_r[2] = anim_r[2] + dt*3
			if anim_r[2] >= 1 then
			    anim_r[1], anim_r[2] = 2, 1
			end
		end
		if anim_r[1] == 2 then
		    anim_r[3] = anim_r[3] + dt*3
			SetShapeLocalTransform(Shell_Shape, Transform(Vec(0.175, -0.37-(1-math.min(anim_r[3], 1))*0.5, -0.6), QuatEuler(-75, 0, 0)))
			if anim_r[3] >= 1 then
			    anim_r[1], anim_r[3] = 2.1, 0
				PlaySound(loading_ammo_sound, GetPlayerCameraTransform().pos)
			end
		end
		if anim_r[1] == 2.1 then
		    anim_r[3] = anim_r[3] + dt*3
			SetShapeLocalTransform(Shell_Shape, Transform(VecLerp(Vec(0.175, -0.37, -0.6), Vec(0.175, -0.26, -0.75), math.min(anim_r[3], 1)), QuatSlerp(QuatEuler(-75, 0, 0), QuatEuler(-90, 0, 0), math.min(anim_r[3], 1))))
			if anim_r[3] >= 1 then
			    ammo, clip = ammo + 1, clip - 1
				if unlimited_ammo then clip = 40 end
			    if ((ammo < 4 and not loaded) or (ammo < 5 and loaded)) and stop_reload == 0 and clip > 0 then anim_r[1], anim_r[3] = 2, 0 else anim_r[1], anim_r[3] = 3, 0 end
				if stop_reload == 2 then 
				    loading, anim_l[1] = true, 1 
					anim_r[1], anim_r[3] = 3, 0
				end
			end
		end
		if anim_r[1] == 3 then
		    anim_r[2] = anim_r[2] - dt*3
			if anim_r[2] <= 0 then
			    anim_r[1], anim_r[2] = 0, 0
				reloading = false
			end
		end
		if (InputPressed(input_lever_action) and not reloading and not loading) or (no_action and recoil < 0.75 and not reloading and not loading and not loaded and ammo > 0) then 
		    loading = true
			anim_l[1] = 1
			stop_reload = 0
		end
		if InputDown("rmb") and not grabing then
            aim_progress = math.min(aim_progress + dt * 5, 1)
        else
            aim_progress = math.max(aim_progress - dt * 5, 0)
        end
		if anim_l[1] == 1 then
		    anim_l[2] = anim_l[2] + dt*3
			if anim_l[2] >= 1 then
			    anim_l[1], anim_l[2] = 2, 1
				PlaySound(loading_sound, GetPlayerCameraTransform().pos)
			end
		end
		if anim_l[1] == 2 then
		    anim_l[3] = anim_l[3] + dt*5
			if anim_l[3] >= 1 then
			    anim_l[1], anim_l[2] = 3, 1
				if loaded and ammo > 0 then ammo = ammo - 1 end
				eject_sheel()
				if ammo > 0 then shell_loaded = true end
			end
		end
		if anim_l[1] == 3 then
		    anim_l[3] = anim_l[3] - dt*4
			if anim_l[3] <= 0 then
			    anim_l[1], anim_l[3] = 4, 0
				if ammo == 0 then loaded = false end
				if ammo > 0 then loaded = true end
				loading = false
				if stop_reload == 3 and clip > 0 then reloading, anim_r[1], stop_reload = true, 1, 0 end
				if stop_reload == 4 then 
				    anim_l[1], anim_l[2], stop_reload = 2, 1, 0 
				    PlaySound(loading_sound, GetPlayerCameraTransform().pos)
				end
			end
		end
		if anim_l[1] == 4 then
		    anim_l[2] = anim_l[2] - dt*3
			if anim_l[2] <= 0 then
			    anim_l[1], anim_l[2] = 0, 0
			end
		end
		SetShapeLocalTransform(ShotGun_Shapes[4], Transform(Vec(0.15, -0.3, -1.25+anim_l[3]*0.29), QuatEuler(-90, 0, 0)))
		local tr = Transform()
		tr.pos = VecAdd(tr.pos, Vec(0, 0, recoil*0.5))
		tr.pos = VecAdd(tr.pos, VecScale(Vec(-0.2, 0.125, 0), aim_progress))
		if stop_reload ~= 2 then tr = Transform(VecLerp(tr.pos, Vec(0.8, -0.2, -0.2), anim_l[2]), QuatSlerp(tr.rot, QuatEuler(0, 80, 35), anim_l[2])) end
		tr = Transform(VecLerp(tr.pos, Vec(0.9, 0.1, -0.2), anim_r[2]), QuatSlerp(tr.rot, QuatEuler(0, 45, -60), anim_r[2]))
		if stop_reload == 2 then tr = Transform(VecLerp(tr.pos, Vec(0.8, -0.2, -0.2), anim_l[2]), QuatSlerp(tr.rot, QuatEuler(0, 80, 35), anim_l[2])) end
		SetToolTransform(tr)
	end
	local delete_bullet = {}
	local bullet_step = 4
	for i = 1, #bullets do
	    local hit, dis, normal, shape = QueryRaycast(bullets[i][1], bullets[i][2], bullet_step+0.1, 0.025)
		if hit then
		    local hitPoint = VecAdd(bullets[i][1], VecScale(bullets[i][2], dis))
	        local mat, r, g, b = GetShapeMaterialAtPosition(shape, hitPoint)
			local body = GetShapeBody(shape)
			ApplyBodyImpulse(body, hitPoint, VecAdd(GetBodyVelocity(), VecScale(bullets[i][2], 100)))
			if ammo_type == 5 then ApplyBodyImpulse(body, hitPoint, VecAdd(GetBodyVelocity(), VecScale(bullets[i][2], 3500))) end
			if (mat == "glass" or mat == "wood" or mat == "plastic") and bullets[i][4] > 0 and ammo_type ~= 1 and ammo_type ~= 2 then
			    if smoke_impact > 0 and (ammo_type == 4 or ammo_type == 1 or ammo_type == 5) then
			    particleSystemgun(bullets[i][1], bullets[i][2], dis, normal, shape)
			    end
				if ammo_type == 0 then MakeHole(hitPoint, 0.8, 0.7, 0.65) end
				if ammo_type == 3 then MakeHole(hitPoint, 0.15, 0.1, 0.07) end
				if ammo_type == 4 then for u = 1, 1 do MakeHole(VecAdd(hitPoint, VecScale(VecScale(bullets[i][2], 0.1), u)), 0.05/(u), 0.02/(u), 0.01/(u)) end end
				if ammo_type == 5 then for u = 1, 5 do MakeHole(VecAdd(hitPoint, VecScale(VecScale(bullets[i][2], 0.1), u)), 0.2/(u), 0.15/(u), 0.08/(u)) end end
			    if smoke_impact > 0 and ammo_type ~= 4 then for u = 1, math.min(math.floor(smoke_impact/2), 1) do
				    ParticleReset()
				    ParticleColor(r, g, b, 1, 1, 1)
					ParticleType("smoke")
					ParticleTile(0)
					ParticleAlpha(1, 0)
					ParticleRadius(.5)
			        SpawnParticle(VecAdd(bullets[i][1], VecScale(bullets[i][2], dis)), VecScale(VecNormalize(Vec(math.random(-1, 1), math.random(-1, 1), math.random(-1, 1))), 2), 2) 
			    end end
				if smoke_impact > 0 and ammo_type == 1 then for u = 1, math.min(math.floor(smoke_impact), 1) do
				    ParticleTile(4)
			        ParticleColor(1, 1, 0.2)
			        ParticleRadius(0.05, 0.01)
			        ParticleAlpha(1, 0)
			        ParticleEmissive(10, 0)
			        ParticleSticky(0.5)
			        local pos = hitPoint
			        local vel = VecAdd(VecSub(Vec(0, 0, 0), bullets[i][2]), VecScale(Vec(math.random()-0.5, math.random()-0.5, math.random()-0.5), 40))
			        SpawnParticle(pos, vel, 1)
				end end
				if ammo_type ~= 3 then bullets[i][1] = VecAdd(bullets[i][1], VecScale(bullets[i][2], 2)) end
				bullets[i][4] = bullets[i][4] - 1
			else
			    if smoke_impact > 0 and (ammo_type == 4 or ammo_type == 1 or ammo_type == 5) then
			    particleSystemgun(bullets[i][1], bullets[i][2], dis, normal, shape)
			    end
			    if ammo_type == 0 then MakeHole(hitPoint, 0.8, 0.7, 0.65) end
				if ammo_type == 1 then 
				    SpawnFire(hitPoint) 
					for u = 1, 1 do MakeHole(VecAdd(hitPoint, VecScale(VecScale(bullets[i][2], 0.1), u)), 0.05/(u), 0.02/(u), 0.01/(u)) end
				end
				if ammo_type == 2 then Explosion(hitPoint, 0.1) end
				if ammo_type == 3 then for u = 1, 1 do MakeHole(VecAdd(hitPoint, VecScale(VecScale(bullets[i][2], 0.1), u)), 0.15/(u), 0.11/(u), 0.07/(u)) end end
				if ammo_type == 4 then for u = 1, 1 do MakeHole(VecAdd(hitPoint, VecScale(VecScale(bullets[i][2], 0.1), u)), 0.05/(u), 0.02/(u), 0.01/(u)) end end
				if ammo_type == 5 then for u = 1, 5 do MakeHole(VecAdd(hitPoint, VecScale(VecScale(bullets[i][2], 0.1), u)), 0.2/((u-1)*0.25+1), 0.15/((u-1)*0.25+1), 0.08/((u-1)*0.25+1)) end end
			    table.insert(delete_bullet, 1, i)
			    if smoke_impact > 0 and ammo_type ~= 4 then for u = 1, math.min(math.floor(smoke_impact/2), 1) do
				    ParticleReset()
				    ParticleColor(r, g, b, 1, 1, 1)
					ParticleType("smoke")
					ParticleTile(0)
					ParticleAlpha(1, 0)
					ParticleRadius(.5)
			        SpawnParticle(VecAdd(bullets[i][1], VecScale(bullets[i][2], dis)), VecScale(VecNormalize(Vec(math.random(-1, 1), math.random(-1, 1), math.random(-1, 1))), 2), 2) 
			    end end
				if smoke_impact > 0 and ammo_type == 1 then for u = 1, math.min(math.floor(smoke_impact), 1) do
				    ParticleTile(4)
			        ParticleColor(1, 1, 0.2)
			        ParticleRadius(0.05, 0.01)
			        ParticleAlpha(1, 0)
			        ParticleEmissive(10, 0)
			        ParticleSticky(0.5)
			        local pos = hitPoint
			        local vel = VecAdd(VecSub(Vec(0, 0, 0), bullets[i][2]), VecScale(Vec(math.random()-0.5, math.random()-0.5, math.random()-0.5), 8))
			        SpawnParticle(pos, vel, 1)
				end end
			end
		else
			--ParticleType("plain")
		    ParticleTile(4)
			ParticleColor(1, 1, 0.2)
			ParticleRadius(0.05, 0.01)
			ParticleAlpha(1, 0)
			ParticleEmissive(10, 0)
			ParticleSticky(0.5)
			local pos = bullets[i][1]
			local vel = VecAdd(VecSub(Vec(0, 0, 0), bullets[i][2]), VecScale(Vec(math.random()-0.5, math.random()-0.5, math.random()-0.5), 0.5*bullets[i][3]))
			if ammo_type == 1 then SpawnParticle(pos, vel, 0.5) end
		    bullets[i][1] = VecAdd(bullets[i][1], VecScale(bullets[i][2], bullet_step))
			bullets[i][3] = bullets[i][3] + 1
			DrawLine(VecSub(bullets[i][1], bullets[i][2]), bullets[i][1])
		end
		if bullets[i][3] >= 100 then table.insert(delete_bullet, 1, i) end
	end
	if #delete_bullet ~= 0 then
	    for i = 1, #delete_bullet do
		    table.remove(bullets, delete_bullet[i])
		end
	end
end

function draw()
    if GetString("game.player.tool") == tool_name and GetPlayerVehicle() == 0 then
        UiPush()
	        UiTranslate(UiCenter(), UiHeight()-60)
		    UiAlign("center middle")
		    UiColor(1, 1, 1)
		    UiFont("bold.ttf", 32)
		    UiTextOutline(0,0,0,1,0.1)
			local clip_text
			local ammo_text
			if unlimited_clip then clip_text = "inf" else clip_text = clip end
			if unlimited_ammo then ammo_text = "inf" else ammo_text = ammo end
		    UiText(ammo_text .. "/"..clip_text) 
	    UiPop()
		UiPush()
		    UiTranslate(UiCenter()-60, UiHeight()-60)
		    UiAlign("center middle")
		    UiColor(1, 1, 1)
		    UiFont("bold.ttf", 32)
		    UiTextOutline(0,0,0,1,0.1)
			UiScale(0.5)
		    if not no_action then if loaded then UiImage("MOD/img/Ready.png") else UiImage("MOD/img/Empty.png") end end
			if no_action then if loaded then UiImage("MOD/img/ReadyAuto.png") else UiImage("MOD/img/EmptyAuto.png") end end
		UiPop()
		UiPush()
	        UiTranslate(UiCenter(), UiHeight()-120)
		    UiAlign("center middle")
		    UiColor(1, 1, 1)
		    UiFont("bold.ttf", 32)
		    UiTextOutline(0,0,0,1,0.1)
			local type_text
		    if ammo_type == 0 then type_text = "Normal Ammo" elseif ammo_type == 1 then type_text =  "Dragon's Breath" elseif ammo_type == 2 then type_text =  "Explosive Ammo" elseif ammo_type == 3 then type_text =  "Small Ammo" elseif ammo_type == 4 then type_text =  "V.S. Ammo" else type_text =  "Slug Shell" end
			UiText(type_text)
	    UiPop()
	end
end
